;------------------------------------------------------------
;   LEMON (LEDTP풓^j^) Rev 0.04
;------------------------------------------------------------
;   VX-3/VX-4/FX-870P/PB-1000/C/AI-1000
;------------------------------------------------------------
; N@
; MENÚAp̃[_N
;------------------------------------------------------------
; @
;------------------------------------------------------------
PB1000:	EQU	1	;PB-1000
PB1000C:EQU	2	;PB-1000C
FX870P:	EQU	3	;FX-870P
AI1000:	EQU	4	;AI-1000
VX3:	EQU	5	;VX-3
;------------------------------------------------------------
MODEL:	EQU	FX870P	;p@

;------------------------------------------------------------
; 萔
;------------------------------------------------------------
REPT:	EQU	10	;L[s[g(10msP)
WAITT:	EQU	100	;WAITx(1`65535)

#if (MODEL=PB1000)|(MODEL=PB1000C)
;------------------------------------------------------------
; WORK AREA(PB-1000/C)
;------------------------------------------------------------
INTOP:	EQU	&H6000	;INTOP(Ԍobt@)
LEDTP:	EQU	&H6201	;LCD\hbgobt@
KYSTA:	EQU	&H68D2	;L[͏
KYREP:	EQU	&H68D8	;L[s[g
#if MODEL=PB1000
;------------------------------------------------------------
; BIOS Routine(PB-1000)
;------------------------------------------------------------
TCAPS:	EQU	&H015B	;-->啶ϊ
CROFF:	EQU	&H913F	;J[\OFF(KYIÑJ[\\OFFɂ)
KYIN:	EQU	&HE8B9	;L[(CALCALCMEMOINNEWALLs@\t)
#else
;------------------------------------------------------------
; BIOS Routine(PB-1000C)
;------------------------------------------------------------
TCAPS:	EQU	&H015B	;-->啶ϊ
CROFF:	EQU	&H91F0	;J[\OFF(KYIÑJ[\\OFFɂ)
KYIN:	EQU	&HEAAD	;L[(CALCALCMEMOINNEWALLs@\t)
#endif
#endif
#if MODEL=FX870P
;------------------------------------------------------------
; WORK AREA(FX-870P/VX-4)
;------------------------------------------------------------
INTOP:	EQU	&H1000	;INTOP(Ԍobt@)
KYSTA:	EQU	&H1114	;L[͏
KYREP:	EQU	&H1119	;L[s[g
LEDTP:	EQU	&H123C	;LCD\hbgobt@
;------------------------------------------------------------
; BIOS Routine(FX-870P/VX-4)
;------------------------------------------------------------
TCAPS:	EQU	&H00B6	;-->啶ϊ($0-->$0)
CROFF:	EQU	&H032E	;J[\OFF(KYIÑJ[\\OFFɂ)
KYIN:	EQU	&H03A4	;WL[͏i$0ɓ͂ꂽL[R[hj
BIOS:	EQU	&H5321	;BIOS(BANK0)R[BANK1ɖ߂
#endif
#if MODEL=VX3
;------------------------------------------------------------
; WORK AREA(VX-3)
;------------------------------------------------------------
INTOP:	EQU	&H6000	;INTOP(Ԍobt@)
KYSTA:	EQU	&H621B	;L[͏
KYREP:	EQU	&H6220	;L[s[g
LEDTP:	EQU	&H6343	;LCD\hbgobt@
;------------------------------------------------------------
; BIOS Routine(VX-3)
;------------------------------------------------------------
TCAPS:	EQU	&H013E	;-->啶ϊ
CROFF:	EQU	&H1FAE	;J[\OFF(KYIÑJ[\\OFFɂ)
KYIN:	EQU	&H03D1	;WL[͏i$0ɓ͂ꂽL[R[hj
BIOS:	EQU	&H5CA7	;BIOS(BANK0)R[BANK1ɖ߂
#endif
#if MODEL=AI1000
;------------------------------------------------------------
; WORK AREA(AI-1000)
;------------------------------------------------------------
INTOP:	EQU	&H0000	;INTOP(Ԍobt@)
KYSTA:	EQU	&H09E5	;L[͏
KYREP:	EQU	&H09EA	;L[s[g
LEDTP:	EQU	&H0201	;LCD\hbgobt@
FONTAD:	EQU	&H0DBB	;tHgi[Ԓn(BANK0)
;------------------------------------------------------------
; BIOS Routine(AI-1000)
;------------------------------------------------------------
TCAPS:	EQU	&H01EC	;-->啶ϊ
CROFF:	EQU	&H29E8	;J[\ON(KYIÑJ[\\OFFɂ)
KYIN:	EQU	&H0460	;WL[̓[`($0=L[R[h)
BIOS:	EQU	&H9881	;BIOS(BANK0)R[BANK1ɖ߂(FX-870P &H5321)
#endif

;------------------------------------------------------------
; 
;------------------------------------------------------------
	ORG	LEDTP+24	;LEDTPɏ풓
	START	TOP		;

TOP:
	LD	$19,REPT	;s[gԂZbg(10msP)
	LD	$23,$31		;J[\ʒu=0
#if (MODEL=PB1000)|(MODEL=PB1000C)
	XRW	$24,$24		;oN0Zbg/view[hɂ
#else
	LDW	$24,$30		;oN1Zbg/view[hɂ
#endif
	LDW	$26,INTOP	;擪AhX

;------------------------------------------------------------
; C
; ́F$26,$27 --- DUMPJnAhX
;     F$25 ---- 샂[h(0:VIEW , 1:EDIT)
;------------------------------------------------------------
MAIN:	CAL	DUMP		;_vXg\

MKEY:	CAL	KEYIN		;L[($0:̓R[h)

	SBC	$0,12		;[CLR]L[
	JR	Z,KEY05		;

	SBC	$0,18		;[INS]L[
	JR	NZ,KEY10	;

KEY05:	LD	$20,5		;EDIT̃J[\ʒu
	LDW	$21,$26		;EDITJnAhX
	XR	$25,$30,MAIN	;EDIT[hZbg

KEY10:	SBC	$25,$30		;EDIT[hł
	JR	Z,EDIT		;YES

	SBC	$0,"/"		;oN؂ւv
	JR	NZ,KEY20	;

	AD	$24,$30		;oNԍXV
	AN	$24,3,MAIN	;ʍĕ\

KEY20:	SBC	$0,"-"		;\AhX؂ւ
	JR	NZ,KEY21	;

	LD	$23,$31		;J[\ʒu0
	CAL	GETHEX		;ʎ擾
	LD	$27,$17		;
	CAL	GETHEX		;ʎ擾
	LD	$26,$17,MAIN	;

KEY21:
	SBC	$0,28		;[->]L[
	JR	NZ,KEY25	;

	ADW	$26,$10,MAIN	;ǂݏoAhXZ(+24)

KEY25:	SBC	$0,29		;[<-]L[
	JR	NZ,KEY30	;

	SBW	$26,$10,MAIN	;ǂݏoAhXZ(-24)

KEY30:	SBC	$0,31		;[]L[
	JR	NZ,KEY50	;

KEY45:	ADW	$26,$2,MAIN	;ǂݏoAhXZ(+8)

KEY50:	SBC	$0,30		;[]L[
	JR	NZ,MKEY		;J[\L[ɂďI
KEY55:	SBW	$26,$2,MAIN	;ǂݏoAhXZ(-8)

;------------------------------------------------------------
; dchs
; ́F$23 -- J[\ʒu
; óF$17 --- ̓R[h
;------------------------------------------------------------
EDIT:
	;------------------------
	; 16i͏
	;------------------------
	PHU	$0		;L[R[hۑ
	CAL	GHEX		;16i()
	PPU	$0		;L[R[hA
	JR	NC,EDT20	;16iȊO̓͂

	CAL	GETHEX5		;ʌɌJ荞
	CAL	KEYIN		;l()

	SBC	$0,12		;[CLR]L[͂
	JR	Z,KEY05		;EDIT[h𔲂

	SBC	$0,18		;[INS]L[͂
	JR	Z,KEY05		;EDIT[h𔲂

	CAL	GHEX		;16i()
	JR	NC,MAIN		;͊ԈႢ́A̓LZ

	CAL	GETHEX4		;ʂɌJ荞

	CAL	SETBANK		;oNw
	ST	$17,($21)	;f[^
#if (MODEL=PB1000)|(MODEL=PB1000C)
	CAL	RESETBANK	;oNɖ߂
#else
	PST	UA,&H55		;oNɖ߂
#endif

	CAL	DUMP		;ʍXV
	JR	EDT25		;[->]L[s

	;------------------------
	; J[\ړ
	;------------------------
EDT20:	SBC	$0,28		;[->]L[
	JR	NZ,EDT30	;

EDT25:	CAL	GCURS		;J[\/ʒu擾
	ADW	$21,$30		;EDITAhXXV(+1)

	SBC	$20,90		;ʍŏIł
	JR	NZ,EDT26	;NO

	LD	$20,69,KEY45	;J[\[Ɉړ

EDT26:	SBC	$0,26		;ʉE[ł
	JR	NZ,EDT27	;NO
	AD	$20,8		;J[\s(+8)
EDT27:	AD	$20,3		;J[\ړ(+3)

ECURS:	CAL	EDCURS		;EDITJ[\\
MKEYJ:	JP	MKEY		;L[͑҂

EDT30:	SBC	$0,29		;[<-]L[
	JR	NZ,EDT40	;

	CAL	GCURS		;J[\/ʒu擾
	SBW	$21,$30		;EDITAhXXV(-1)

	SBC	$20,5		;ʐ擪ł
	JR	NZ,EDT34	;NO

	LD	$20,26,KEY55	;J[\E[Ɉړ/ʂXN[

EDT34:	SBC	$0,5		;ʍ[ł
	JR	NZ,EDT35	;NO

	SB	$20,8		;J[\s(-8)
EDT35:	SB	$20,3,ECURS	;J[\ړ(-3)

EDT40:	SBC	$0,31		;[]L[
	JR	NZ,EDT50	;

	CAL	EDCURS		;J[\
	ADW	$21,$2		;EDITAhXXV

	SBC	$20,64		;ʍŉił
	JP	NC,KEY45	;YES-->[]XN[

	AD	$20,32,ECURS	;J[\s(+8)

EDT50:	SBC	$0,30		;[]L[
	JR	NZ,MKEYJ	;

	CAL	EDCURS		;J[\
	SBW	$21,$2		;EDITAhXXV(-8)

	SBC	$20,32		;ʍŏił
	JP	C,KEY55		;YES-->[]XN[
	SB	$20,32,ECURS	;J[\s(-8)

;------------------------------------------------------------
; J[\/ʒu擾
;------------------------------------------------------------
GCURS:	CAL	EDCURS		;EDITJ[\
	LD	$0,$20		;J[\擾
	AN	$0,31		;J[\ʒu}XN
	RTN

;------------------------------------------------------------
; 16i_v
; ́F$26,$27 --- DUMPJnAhX
;------------------------------------------------------------
DUMP:	LD	$23,$31		;J[\ʒu擪ɂ
	PRE	IX,$26		;f[^ǂ݂擪AhXZbg

	LD	$16,3		;Rs\

DUMP10L:
	GRE	IX,$0		;AhX擾($0,$1)

	PHU	$0		;ʌۑ
	BYDW	$1		;ʌ\
	CAL	OUTHEX		;
	PPU	$0		;ʌ\
	CAL	OUTHEX		;

	LDW	$4,&H0800	;`FbNT

DUMP20L:
	CAL	SPC		;Xy[Xo

	CAL	SETBANK		;$24ɏ]ăoNZbg
	LDI	$0,(IX+$31)	;PoCgo
	AD	$4,$0		;`FbNTZ
#if (MODEL=PB1000)|(MODEL=PB1000C)
	CAL	RESETBANK	;oNɖ߂
#else
	PST	UA,&H55		;oNɖ߂
#endif

	CAL	OUTHEX		;1oCg\

	SB	$5,$30		;8oCg_vI?
	JR	NZ,DUMP20L	;NO

	LD	$0,":"		;":"\
	CAL	OUTLC		;

	LD	$0,$4		;`FbNT\
	CAL	OUTHEX		;
	CAL	SPC		;Xy[Xo

	CAL	WAIT		;x(LCD΍)

	SB	$16,$30		;3s\I
	JR	NZ,DUMP10L	;NO

	LD	$0,"["		;"["\
	CAL	OUTLC		;

	PRE	IX,$26		;f[^ǂ݂擪AhXZbg
	LDW	$16,24		;24\
DUMP30L:
	CAL	SETBANK		;$24ɏ]ăoNZbg
	LDI	$0,(IX+$31)	;PoCgǂݍ
#if (MODEL=PB1000)|(MODEL=PB1000C)
	CAL	RESETBANK	;oNɖ߂
#else
	PST	UA,&H55		;oNɖ߂
#endif

	CAL	OUTLC		;\

	SB	$16,$30		;3s\I
	JR	NZ,DUMP30L	;NO

	LD	$0,"]"		;"]"\
	CAL	OUTLC		;

	LD	$0,"0"		;oNԍ\
	AD	$0,$24		;
	CAL	OUTLC		;

	PRE	IX,$26		;f[^ǂ݂擪AhXZbg
	LD	$16,3		;24oCgǂݏo
DUMP40L:
	CAL	SETBANK		;$24ɏ]ăoNZbg
	LDIM	$4,(IX+$31),8	;OtBbNp^[\
	STLM	$4,8		;
#if (MODEL=PB1000)|(MODEL=PB1000C)
	CAL	RESETBANK	;oNɖ߂
#else
	PST	UA,&H55		;oNɖ߂
#endif

	SB	$16,$30		;\I?
	JR	NZ,DUMP40L	;NO

	SBC	$25,$30		;EDIT[h?
	JR	NZ,DUMPE	;

	CAL	EDCURS		;EDITJ[\\
DUMPE:
;------------------------------------------------------------
; WAITiLCD̂ŁEEEj
;------------------------------------------------------------
WAIT:
	LDW	$0,WAITT	;xlZbg
WAIT1:	SBW	$0,$30		;xs
	JR	NZ,WAIT1	;
	RTN

;------------------------------------------------------------
; oCiASCIIϊ
; ́F$0 --- ϊoCif[^(4Bit)
; óF$0 --- AXL[f[^
;------------------------------------------------------------
B2A:	AD	$0,"0"		;lASCIIR[hZ
	SBC	$0,&H3A		;l(0`9) ?
	RTN	C		;YES
	AD	$0,7		;At@xbgR[hZ
	RTN

;------------------------------------------------------------
; 16iP͏
; ́F$23 -- J[\ʒu
; óF$0 --- ̓R[h
;     F$1 --- ͐l(0`15)
;------------------------------------------------------------
GHEX:	LD	$1,$0		;L[R[hۑ
	SB	$1,"0"		;"0"`"9"?
	JR	C,GHEXNC	;No
	SBC	$1,10		;lL[͂ɂI
	RTN	C		;Yes
	SB	$1,7		;&HA`&HF ?
	JR	C,GHEXNC	;No
	SBC	$1,16		;
	RTN	C		;Yes

GHEXNC:	SBC	$30,$31		;NC
	RTN

;------------------------------------------------------------
; HEX(2)\
; ́F$0 --- oCif[^
;       $23 -- \Jnʒu
; óF$23 -- XVꂽ\ʒu
;       $0`$3𗘗p
;------------------------------------------------------------
OUTHEX:	PHU	$0		;ϊf[^ۑ

	DID	$0		;ʌo
	CAL	B2A		;BINARY-->ASCII
	CAL	OUTLC		;ʌ\

	PPU	$0		;ϊf[^A
	AN	$0,&HF		;ʌo
	CAL	B2A		;BINARY-->ASCII
;	JR	OUTLC		;ʕ\

;------------------------------------------------------------
; LN^P\(LCD֒ڕ`)
; ́F$0 --- \R[h
;     F$23 -- J[\ʒu(0`127)
; óF$23 -- XVꂽJ[\ʒu(+1)
;------------------------------------------------------------
OUTLC:	LD	$10,$23		;LCD؂ւvH
	AN	$10,15		;
	JR	NZ,OUTL5	;NO

;	LD	$10,&H82	;\[h(Normal,OtBbN)
	CAL	LCDS0		;J[\ʒuɊYLCDp[^Zbg
OUTL5:
	SB	$0,&H20		;LN^R[h␳
	JR	NC,OUTL10	;

	LD	$0,$31		;NullR[hZbg
OUTL10:
	LD	$1,$31		;tHgAhXvZ
	BIUW	$0		;*2(2{)
	LDW	$10,$0		;
	BIUW	$10		;*2(4{)
	ADW	$10,$0		;(6{쐬)

#if (MODEL=PB1000)|(MODEL=PB1000C)
	LDW	$0,&H8000	;PB-1000/CtHgAhX쐬
	ADW	$10,$0		;
#endif
#if MODEL=AI1000
	LDW	$0,FONTAD	;AI-1000tHgAhX쐬
	ADW	$10,$0		;
#endif
	GRE	IX,$0		;IXۑ
	PRE	IX,$10		;FONTAhXw

#if (MODEL=PB1000)|(MODEL=PB1000C)
	PST	UA,$31		;BANK 0ݒ(IX)
	LDM	$10,(IX+$31),6	;FONTǂݍ
	PST	UA,&H50		;BANKɖ߂
#endif
#if (MODEL=FX870P)|(MODEL=VX3)
	PST	UA,&H65		;BANK 2ݒ(IX)
	LDM	$10,(IX+$31),6	;FONTǂݍ
	PST	UA,&H55		;BANKɖ߂
#endif
#if MODEL=AI1000
	PST	UA,&H45		;BANK 0ݒ(IX)
	LDM	$10,(IX+$31),6	;FONTǂݍ
	PST	UA,&H55		;BANKɖ߂
#endif
	PRE	IX,$0		;IXA

	AD	$23,$30		;J[\ʒuXV
OUTLE:
	STLM	$10,6		;tHgo
	RTN

SPC:	LD	$0," ",OUTLC	;Xy[X\

;------------------------------------------------------------
; EDITJ[\\(LCDڐ)
; ́F$20 -- EDITJ[\ʒu(0`127)
;     F$21$22 -- EDITAhX
;     F$26$27 -- DUMP\JnAhX
; óFȂ
;------------------------------------------------------------
EDCURS:	LDW	$0,$21		;]\
	SBW	$0,$26		;
	AD	$0,97		;
	LD	$23,$0		;
	CAL	CURS		;
	LD	$23,$20,CURS	;EDITJ[\\

;------------------------------------------------------------
; 16i2͏
; ́F$23 -- J[\ʒu
; óF$17 --- ̓R[h
;------------------------------------------------------------
GETHEX:	CAL	CURS		;J[\\

GETHEX1:CAL	KEYIN		;L[
	CAL	GHEX		;16i()
	JR	NC,GETHEX1	;͊ԈႢ

	CAL	GETHEX5		;XV

GETHEX3:CAL	KEYIN		;L[
	CAL	GHEX		;16i()
	JR	NC,GETHEX3	;͊ԈႢ

GETHEX4:OR	$17,$1		;ʂɌJ荞
	CAL	CURS		;J[\
	JR	OUTLC		;\

GETHEX5:LD	$17,$1		;ʂɌJ荞
	DIU	$17		;
	CAL	CURS		;J[\
	CAL	OUTLC		;\/J[\ړ(+1)
;	JP	CURS		;J[\\

;------------------------------------------------------------
; J[\\(LCDڐ)
; ́F$0 --- \R[h
;     F$23 -- J[\ʒu(0`127)
; óF$23 -- XVꂽJ[\ʒu(+1)
;------------------------------------------------------------
CURS:	LD	$10,&H22	;\[h(XOR,OtBbN)
	CAL	LCDS		;J[\ʒuɊYLCDp[^Zbg
	XRM	$10,$10,6	;J[\LN^Zbg
	INVM	$10,6		;
	CAL	OUTLE		;J[\\
LCDS0:	LD	$10,&H82	;\[h(Normal,OtBbN)
;	CAL	LCDS		;J[\ʒuɊYLCDp[^Zbg

;------------------------------------------------------------
; J[\ʒuɊYLCDp[^ݒ
; ́F$0 --- \R[h
;     F$23 -- J[\ʒu(0`127)
; óFȂ
;       $11`13𗘗p
;------------------------------------------------------------
LCDS:	;------------------------
	; LCD\[h쐬($11)
	;------------------------
	LD	$11,$23		;J[\ʒuǂݏo
	AN	$11,16		;LCD1/LCD2o
	OR	$11,$10		;\[h쐬

	;------------------------
	; ʒu쐬($12)
	;------------------------
	LD	$12,$23		;ʒuo
	AN	$12,7		;
	LD	$13,$12		;1{ۑ
	BIU	$12		;2{
	AD	$12,$13		;3{쐬
	BIU	$12		;6{
	BIU	$12		;12{

	LD	$13,$23		;BLOCKʒuOR
	AN	$13,8		;
	DIU	$13		;
	OR	$12,$13		;

	;------------------------
	; sʒu쐬($13)
	;------------------------
	LD	$13,$23		;sʒuo
	DID	$13		;
	BID	$13		;

	PPO	&HC5		;LCDR}h(without HD44352)
	STLM	$11,3		;
	PPO	&HC4		;LCDf[^o̓[hZbg(without HD44352)
	RTN

;------------------------------------------------------------
; L[͏
; ́FȂ
; óF$0 --- L[R[h
;------------------------------------------------------------
KEYIN:
#if (MODEL=PB1000)|(MODEL=PB1000C)
	CAL	CROFF		;J[\OFF
#else
	LDW	$28,CROFF	;J[\OFF
	CAL	RCS		;
#endif
#if MODEL=AI1000
	LDW	$0,KYSTA	;s[gON
	LD	$2,($0)		;
	OR	$2,4		;(Bit2=ON)
	ST	$2,($0)		;
#endif
#if (MODEL=PB1000)|(MODEL=PB1000C)
	LDW	$0,KYSTA	;s[gON
	ST	4,($0)		;(Bit2=ON)
#endif
#if (MODEL=VX3)|(MODEL=FX870P)
	LDW	$0,KYSTA	;s[gON
	ST	6,($0)		;(Bit2,Bit1=ON)
#endif
#if (MODEL=PB1000)|(MODEL=PB1000C)
	CAL	KYIN		;WL[͑҂(KYIN)
	CAL	TCAPS		;At@xbg啶ɕϊ($0)
#else
	LDW	$28,KYIN	;WL[͑҂(KYIN)
	CAL	RCS		;

	LDW	$28,TCAPS	;At@xbg啶ɕϊ($0)
	CAL	RCS		;(ȊO͕ωȂ)
#endif
;------------------------------------------------------------
	LDW	$2,8		;AhXZZbg(LEMONp)
	LDW	$10,24		;AhXZZbg(ʍXVp)
;------------------------------------------------------------

	LDW	$4,KYREP	;s[gԂ𒲐
	LD	$1,($4)		;

	SBC	$1,20		;s[gH
	RTN	NZ		;

	ST	$19,($4)	;ōɂ

	RTN

#if (MODEL=VX3)|(MODEL=FX870P)|(MODEL=AI1000)
;------------------------------------------------------------
; BIOSĂяo(IX,IZ=oN1w)
; ́F$28,$29 --- BIOSĂяoAhX
;------------------------------------------------------------
RCS:	PST	UA,&H54		;oN0w
	JP	BIOS		;BIOS(oN0)Ăяo
#endif
;------------------------------------------------------------
; oN؂ւ
; ́F$24 -- oNԍ(0,1,2,3)
; óFUA --- oNAhX
;------------------------------------------------------------
SETBANK:PRE	IZ,BANK		;oN؂ւ
	LD	$0,(IZ+$24)	;
	PST	UA,$0		;
#if (MODEL=PB1000)|(MODEL=PB1000C)
	PST	IB,&H20		;oN؂ւ͈͂0000H`FFFFH֐ݒ肷
#endif
	RTN

#if (MODEL=PB1000)|(MODEL=PB1000C)
;------------------------------------------------------------
; oN
; ́FȂ
; óFUA,IB
;------------------------------------------------------------
RESETBANK:
	PST	IB,&HA0		;oN؂ւ͈͂8000H`FFFFH֖߂
	PST	UA,&H50		;oNɖ߂
	RTN
#endif

;------------------------------------------------------------
; oN؂ւe[u
;------------------------------------------------------------
#if (MODEL=PB1000)|(MODEL=PB1000C)
BANK:	DB	&H40,&H50,&H60,&H70
#else
BANK:	DB	&H45,&H55,&H65,&H75
#endif
